package model;

import config.subConfig.AxisConfig;

import java.awt.*;

/**
 * 坐标系中物体
 * @author duh
 * @create 2018/7/17 15:00
 * @email duh@elab-plus.com
 **/
public abstract class ModuleInAxis {
    protected static AxisConfig axisPointConfig;
    protected String name;
    //x坐标
    protected int x;
    //y坐标
    protected int y;
    //旋转角度
    protected int scale;

    /**
     * 匹配坐标系
     */
    public void matchAxis(){
//        System.out.println("match before:"+x+","+y+",axis x="+axisPointConfig.getX()+",y="+axisPointConfig.getY());
        x += axisPointConfig.getX();
        y = axisPointConfig.getY()-y;
//        System.out.println("match end:"+x+","+y);
    }

    public static AxisConfig getAxisPointConfig() {
        return axisPointConfig;
    }

    public static void setAxisPointConfig(AxisConfig axisPointConfig) {
        ModuleInAxis.axisPointConfig = axisPointConfig;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x+axisPointConfig.getX();
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y+axisPointConfig.getY();
    }

    public int getScale() {
        return scale;
    }

    public void setScale(int scale) {
        this.scale = scale;
    }
    public abstract void drawSelf(Graphics g);
}
